#!/bin/bash

if [ ! -e $HOME/hydro_extension/exeDir/WPS_GEOG ]; then 
   mkdir -p $HOME/hydro_extension/exeDir
   $HOME/hydro_extension/WRF/bin/get_geo_wps_data_hres.sh
fi
cp  $HOME/hydro_extension/WRF/namelist/namelist.wps.hres $HOME/hydro_extension/WRF/namelist/namelist.wps

rootDir=$HOME/hydro_extension
if [ ! -e $rootDir/exeDir ]; then 
  mkdir -p $rootDir/exeDir
fi
cd $rootDir/WRF/WPS_exe
mv  ../namelist/namelist.wps .
if [ -e geo_em.d01.nc ]; then rm -f geo_em.d01.nc; fi
if [ -e met_em.d01.2018-08-11_18:00:00.nc ]; then rm -f met_em.d01.2018-08-11_18:00:00.nc; fi
if [ ! -e WPS_GEOG ]; then ln -sf $HOME/hydro_extension/exeDir/WPS_GEOG .; fi
./geogrid.exe

echo "Note: cp  geo_em.d01.nc $rootDir/data/DOMAIN/geo_finemesh.nc "
if [ ! -e $rootDir/data/DOMAIN ]; then 
    mkdir $rootDir/data/DOMAIN
fi
cp  geo_em.d01.nc $rootDir/data/DOMAIN/geo_finemesh.nc
cp $rootDir/data/usage.dat .
### $rootDir/utils/drv/create_wrfinput/cwrfInput.exe geo_em.d01.nc wrfinput_d01
$rootDir/data/exeFiles/cwrfInput.exe geo_em.d01.nc wrfinput_d01




echo "wrfinput_d01 $rootDir/data/DOMAIN/."
echo "The domain gif file (domain.eps) is created at $rootDir/data/DOMAIN/."

mv  wrfinput_d01 $rootDir/data/DOMAIN

echo "creating the figure ...... "
ncl < $HOME/hydro_extension/WRF/bin/terrain_wps.ncl
mv *.eps $rootDir/data/DOMAIN

exit


